function standardize(node) {
    if (!node.addEventListener)
        node.addEventListener = function(t, l, c) { this["on"+t] = l; };
    if (!node.dispatchEvent)
        node.dispatchEvent = function(e) { this["on"+e.type](e); };
}
window.onload = function () { init(); };
function init()
{
	var start_year = document.getElementById("start_year");
	standardize(start_year);
	start_year.addEventListener("change", selectChangeEvent, true);

	var start_month = document.getElementById("start_month");
	standardize(start_month);
	start_month.addEventListener("change", selectChangeEvent, true);

	var start_day = document.getElementById("start_day");
	standardize(start_day);
	start_day.addEventListener("change", selectChangeEvent, true);

	var end_year = document.getElementById("end_year");
	standardize(end_year);
	end_year.addEventListener("change", selectChangeEvent, true);

	var end_month = document.getElementById("end_month");
	standardize(end_month);
	end_month.addEventListener("change", selectChangeEvent, true);

	var end_day = document.getElementById("end_day");
	standardize(end_day);
	end_day.addEventListener("change", selectChangeEvent, true);
}
function selectChangeEvent(event)
{
	nonExistDayIsNonDisplayed("start_year", "start_month", "start_day");
	nonExistDayIsNonDisplayed("end_year", "end_month", "end_day");
}
/**
 * ݂Ȃi230Ȃǁj̑I\ɂ
 *
 * @param yearId uNvselectvfID
 * @param monthId uvselectvfID
 * @param dayId uvselectvfID
 */
function nonExistDayIsNonDisplayed(yearId, monthId, dayId) {
	var yearSelect = document.getElementById(yearId);
	var monthSelect = document.getElementById(monthId);
	var daySelect = document.getElementById(dayId);
	var dayOptions = daySelect.options;

	if((yearSelect.options[yearSelect.selectedIndex].value == "----") ||
	   (monthSelect.options[monthSelect.selectedIndex].value == "--"))
	{
		return;
	}
	
	var selectedMonth = parseInt(monthSelect.options[monthSelect.selectedIndex].value, 10);
	
	if (selectedMonth === 2) {
	// 2̏ꍇ
		var selectedYear = parseInt(yearSelect.options[yearSelect.selectedIndex].value, 10);

		for (var i = dayOptions.length - 1; i >= 1; i--) {
			var dayOption = dayOptions[i];
			var dayValue = parseInt(dayOption.value, 10);
			var leapYear = isLeapYear(selectedYear); // [N
			if (dayValue >= 30 || (dayValue === 29 && !leapYear)) {
				dayOption.setAttribute("disabled", "disabled"); // Is\w
				if (dayOption.selected) {
				// 29([NłȂꍇ̂)A30A31̂ꂩIĂꍇ́A2̍ŏIɕύX
					if (leapYear) {
						daySelect.value = "29";
					} else {
						daySelect.value = "28";
					}
				}
			} else if ("disabled" === dayOption.getAttribute("disabled")) {
			// Is\w肪Ă
				dayOption.removeAttribute("disabled");
			} else {
				break;
			}
		}
	} else if (selectedMonth === 4 || selectedMonth === 6 || selectedMonth === 9 || selectedMonth === 11) {
	// ̓30̏ꍇ
		for (var i = dayOptions.length - 1; i >= 1; i--) {
			var dayOption = dayOptions[i];
			var dayValue = parseInt(dayOption.value, 10);
			if (dayValue >= 31) {
				dayOption.setAttribute("disabled", "disabled"); // Is\w
				if (dayOption.selected) {
				// 31IĂꍇ́Ae̍ŏIɕύX
					daySelect.value = "30";
				}
			} else if ("disabled" === dayOption.getAttribute("disabled")) {
			// Is\w肪Ă
				dayOption.removeAttribute("disabled");
			} else {
				break;
			}
		}
	} else {
	// ̓31̏ꍇ
		for (var i = dayOptions.length - 1; i >= 1; i--) {
			var dayOption = dayOptions[i];
			if ("disabled" === dayOption.getAttribute("disabled")) {
			// Is\w肪Ă
				dayOption.removeAttribute("disabled");
			} else {
				break;
			}
		}
	}
}
/**
 * [N
 *
 * @param year N
 *
 * @return [NȂtrueAȊȌꍇfalse
 */
function isLeapYear(year) {
	if (((year % 4 == 0) && (year % 100 != 0)) || (year % 400 == 0))
	{
		return true;
	}
	else
	{
		return false;
	}
}
